# -*- coding: UTF-8 -*-
import json


def get_tags():
    return ['1', '1.5']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)

    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    vsftpd_config_file = runcontext.get_extra_var('VSFTPD_CONFIG_FILE')
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = r'grep -Ev "^\s*#|^\s*$" %s | grep local_umask' % vsftpd_config_file
    tmp_vars["systemvalue1"] = ""
    ret_code = -1

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)

    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]

    tmp_vars["systemvalue1"] = astdout1

    if astdout1 != '':
        local_umask = (astdout1.split('#')[0]).split('=')[1]
        local_umask = local_umask.strip()
        if local_umask.isdigit():
            local_umask = local_umask.zfill(4)
            i = int(local_umask[1])
            j = int(local_umask[2])
            k = int(local_umask[3])
            if i in [0, 1, 2, 3, 4, 5, 6, 7] and j in [2, 3, 6, 7] and k == 7:
                tmp_vars["checkresult1"] = "pass"
    else:
        tmp_vars["checkresult1"] = "pass"

    if tmp_vars["checkresult1"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('r_1_5.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
